// cl/algorithms/algorithm.cpp
#include<cl/algorithms/algorithm.hpp>

namespace ClusLib {

    const boost::any& Additional::get(const std::string &name) 
        const {
        std::map<std::string, boost::any>::const_iterator it;
        it = additional.find(name);
        if (it == additional.end()) {
            FAIL(name << " not found");
        } 

        return it->second;
    }

    void Additional::insert(const std::string &name, 
        const boost::any &val) {
        additional.insert(std::pair<std::string, 
            boost::any>(name, val));
    }

    void Results::reset() {
        CM.clear();
        additional.clear();
    }

    Arguments& Algorithm::getArguments() {
        return _arguments;
    }

    const Results& Algorithm::getResults() const {
        return _results;
    } 

    void Algorithm::reset() const {
        _results.reset();
    }

    void Algorithm::clusterize() {
        setupArguments();
        performClustering();
        reset();
        fetchResults();
    }

    void Algorithm::setupArguments() {
        _ds = _arguments.ds; 
        ASSERT(_ds, "dataset is null");
    }

} 
