// cl/algorithms/centroid.cpp
#include<cl/algorithms/centroid.hpp>
#include<cl/distances/euclideandistance.hpp>
#include<cmath>

namespace ClusLib {

    void Centroid::setupArguments() {
        Algorithm::setupArguments();

        _distance = boost::shared_ptr<Distance>(new
            EuclideanDistance());
    }

    void Centroid::update_dm(Size p, Size q, Size r) 
    	  const {
        Real dist;
        std::set<Size>::iterator it;
        Real sp = _clusterSize[p];
        Real sq = _clusterSize[q];
        for(it = _unmergedClusters.begin();
            it != _unmergedClusters.end(); ++it) {
            if(*it == r) {
                continue;
            }

            dist = std::pow(_dm(p,*it), 2.0)*sp/(sp+sq) + 
                std::pow(_dm(q,*it), 2.0)*sq/(sp+sq) -
                std::pow(_dm(p,q), 2.0)*sp*sq/((sp+sq)*(sp+sq));
            _dm.add_item(r,*it, std::sqrt(dist));
        }
    }

}
