// cl/algorithms/fsc.hpp
#ifndef CLUSLIB_FSC_HPP
#define CLUSLIB_FSC_HPP

#include<cl/algorithms/algorithm.hpp>
#include<cl/datasets/dataset.hpp>
#include<cl/clusters/subspacecluster.hpp>

namespace ClusLib {

    class FSC: public Algorithm {
    protected:
        void setupArguments();
        void performClustering() const;
        void fetchResults() const;
        virtual void initialization() const;
        virtual void iteration() const;
        virtual void updateCenter() const;
        virtual void updateWeight() const;
        virtual void calculateObj() const;
        Real dist(const boost::shared_ptr<Record> &x,
                  const boost::shared_ptr<SubspaceCluster> &c
                  ) const;

        mutable std::vector<boost::shared_ptr<SubspaceCluster> > 
            _clusters;
        mutable std::vector<Size> _CM;
        mutable Real _dObj;
        mutable Size _numiter;
        
        Size _seed;
        Real _alpha;
        Real _epsilon;
        Real _threshold;
        Size _numclust;
        Size _maxiter; 
    };
}

#endif
