// cl/algorithms/kmean.hpp
#ifndef CLUSLIB_KMEAN_HPP
#define CLUSLIB_KMEAN_HPP

#include<cl/algorithms/algorithm.hpp>
#include<cl/clusters/centercluster.hpp>
#include<cl/clusters/pclustering.hpp>
#include<cl/datasets/dataset.hpp>
#include<cl/distances/distance.hpp>
#include<cl/types.hpp>

namespace ClusLib {

    class Kmean: public Algorithm {
    protected: 
        void setupArguments();
        void performClustering() const;
        void fetchResults() const;
        virtual void initialization() const;
        virtual void iteration() const;
        virtual void updateCenter() const;

        mutable std::vector<boost::shared_ptr<CenterCluster> > 
            _clusters;
        mutable std::vector<Size> _CM;
        mutable Real _error;
        mutable Size _numiter;
        
        Size _numclust;
        Size _maxiter;
        Size _seed;
        boost::shared_ptr<Distance> _distance;
    };

}


#endif
