// cl/algorithms/lw.hpp
#ifndef CLUSLIB_LW_HPP
#define CLUSLIB_LW_HPP

#include<cl/algorithms/algorithm.hpp>
#include<cl/clusters/hclustering.hpp>
#include<cl/utilities/nnmap.hpp>
#include<cl/datasets/dataset.hpp>
#include<cl/distances/distance.hpp>
#include<cl/types.hpp>
#include<set>

namespace ClusLib {

    class LW: public Algorithm { 
    protected:
        typedef std::map<Size, boost::shared_ptr<HClustering> > 
            Forest;
        typedef std::map<Size, Size> SizeMap;

        void setupArguments();
        void performClustering() const;
        void fetchResults() const;
        virtual void create_dm() const;
        virtual void init_forest() const;
        virtual void linkage() const;
        virtual void update_dm(Size p, Size q, Size r) 
            const = 0;

        mutable iirMapA _dm;
        mutable std::set<Size> _unmergedClusters;
        mutable Forest _forest;
        mutable SizeMap _clusterSize;
        boost::shared_ptr<Distance> _distance;
    };
}

#endif
