// cl/algorithms/median.cpp
#include<cl/algorithms/median.hpp>
#include<cl/distances/euclideandistance.hpp>
#include<cmath>

namespace ClusLib {

    void Median::setupArguments() {
        Algorithm::setupArguments();

        _distance = boost::shared_ptr<Distance>(new
            EuclideanDistance());
    }

    void Median::update_dm(Size p, Size q, Size r) const {
        Real dist;
        std::set<Size>::iterator it;
        for(it = _unmergedClusters.begin();
            it != _unmergedClusters.end(); ++it) {
            if(*it == r) {
                continue;
            }

            dist = 0.5*std::pow(_dm(p,*it), 2.0)+
                0.5*std::pow(_dm(q,*it), 2.0)-
                0.25*std::pow(_dm(p,q), 2.0);
            _dm.add_item(r,*it, std::sqrt(dist));
        }
    }

}
