// cl/clusters/hclustering.hpp
#ifndef CLUSLIB_HCLUSTERING_HPP
#define CLUSLIB_HCLUSTERING_HPP

#include<cl/patterns/internalnode.hpp>
#include<cl/patterns/leafnode.hpp>
#include<cl/patterns/node.hpp>
#include<cl/utilities/dendrogram.hpp>
#include<cl/clusters/pclustering.hpp>

namespace ClusLib {

    class HClustering {
    public:
        HClustering() {}
        HClustering(const boost::shared_ptr<Node>& root);

        boost::shared_ptr<Node> joinWith(HClustering& hc,
                Real joinValue);
        const boost::shared_ptr<Node>& root() const;
        boost::shared_ptr<Node>& root();
        PClustering get_pc(Size maxclust) const; 
        void save(const std::string &filename, Size p=100) const;

    private:
        boost::shared_ptr<Node> _root;
    };

    inline const boost::shared_ptr<Node>& HClustering::root() 
        const {
        return _root;
    }

    inline boost::shared_ptr<Node>& HClustering::root() {
        return _root;
    }
} 

#endif
