// cl/clusters/pclustering.hpp
#ifndef CLUSLIB_PCLUSTERING_HPP
#define CLUSLIB_PCLUSTERING_HPP

#include<cl/clusters/cluster.hpp> 
#include<cl/utilities/container.hpp>
#include<cl/utilities/nnmap.hpp>

namespace ClusLib {

    class PClustering: 
        public Container<boost::shared_ptr<Cluster> > {
    public:
        friend std::ostream& operator<<(std::ostream& os,
                PClustering& pc);

        PClustering();
        void removeEmptyClusters();
        void createClusterID();
        void save(const std::string& filename);

    private: 
        void print(std::ostream& os);
        void calculate();
        void crosstab();

        bool _bCalculated;
        Size _numclust;
        Size _numclustGiven;
        std::vector<Size> _clustsize;
        std::vector<std::string> _clustLabel;
        std::vector<Size> _CM;
        std::vector<Size> _CMGiven;
        iiiMapB _crosstab;
    }; 

} 
#endif
