// cl/datasets/cattrinfo.hpp
#ifndef CLUSLIB_CATTRINFO_HPP
#define CLUSLIB_CATTRINFO_HPP

#include<cl/datasets/attrinfo.hpp>

namespace ClusLib {

    class CAttrInfo : public AttrInfo {
    public:
        CAttrInfo(const std::string& name);

        CAttrInfo& cast_to_c();
        const CAttrInfo& cast_to_c() const;
        bool can_cast_to_c() const;
        CAttrInfo* clone() const;
        Real distance(const AttrValue&, const AttrValue&) const;
        void set_c_val(AttrValue&, Real) const;
        Real get_c_val(const AttrValue&) const;
        void set_unknown(AttrValue&) const;
        bool is_unknown(const AttrValue&) const;
        void set_min(Real);
        void set_max(Real);
        Real get_min() const;
        Real get_max() const;
        bool equal(const AttrInfo&) const;
  
    protected:
        Real _min;
        Real _max;
    };

    inline Real CAttrInfo::get_c_val(const AttrValue& av)
       	const {
        return boost::get<Real>(av._value);
    }

    inline CAttrInfo& CAttrInfo::cast_to_c() { 
        return *this;
    }

    inline const CAttrInfo& CAttrInfo::cast_to_c() const {
        return *this;
    }

    inline bool CAttrInfo::can_cast_to_c() const {
        return true;
    }

    inline void CAttrInfo::set_min(Real min) {
        _min = min;
    }

    inline void CAttrInfo::set_max(Real max) {
        _max = max;
    }

    inline Real CAttrInfo::get_min() const {
        return _min;
    }

    inline Real CAttrInfo::get_max() const {
        return _max;
    }
}

#endif
