// cl/distances/mixeddistance.cpp
#include<cl/distances/mixeddistance.hpp>
#include<cmath>
#include<iostream>

namespace ClusLib {

    Real MixedDistance::operator()(
        const boost::shared_ptr<Record> &x, 
        const boost::shared_ptr<Record> &y) const {
        boost::shared_ptr<Schema> schema = x->schema();
        ASSERT(*schema==*(y->schema()), "schema does not match");

        Real d1 = 0.0;
        Real d2 = 0.0; 
        for(Size i=0;i<schema->size();++i){
            if((*schema)[i]->can_cast_to_c()) {
                d1 += std::pow(std::fabs(
                    (*schema)[i]->distance((*x)[i],(*y)[i])),2.0);
            } else {
                d2 += (*schema)[i]->distance((*x)[i],(*y)[i]);
            }
        } 

        return d1 + _beta*d2;
    } 
}
