// cl/distances/mixeddistance.hpp
#ifndef CLUSLIB_MIXEDDISTANCE_HPP
#define CLUSLIB_MIXEDDISTANCE_HPP

#include<cl/distances/euclideandistance.hpp>
#include<cl/distances/simplematchingdistance.hpp>
#include<cl/types.hpp>

namespace ClusLib {

    class MixedDistance: public Distance { 
    public:
        MixedDistance();
        MixedDistance(Real beta);
        Real operator()(const boost::shared_ptr<Record>&, 
            const boost::shared_ptr<Record>& ) const;

    protected:
        Real _beta;
    };

    inline MixedDistance::MixedDistance() 
        : Distance("Mixed Distance"), _beta(1.0) {
    }

    inline MixedDistance::MixedDistance(Real beta) 
        : Distance("Mixed Distance"), _beta(beta) {
    }
}

#endif
