// cl/distances/simplematchingdistance.cpp
#include<cl/distances/simplematchingdistance.hpp>
#include<cl/datasets/record.hpp>
#include<cmath>

namespace ClusLib {

    Real SimpleMatchingDistance::operator()(
        const boost::shared_ptr<Record> &x, 
        const boost::shared_ptr<Record> &y) const {
        boost::shared_ptr<Schema> schema = x->schema();
        ASSERT(*schema==*(y->schema()), "schema does not match");

        Real temp = 0.0;
        for(Size i=0;i<schema->size();++i){
            temp += (*schema)[i]->distance((*x)[i],(*y)[i]);
        }

        return temp;
    }

}
