// cl/patterns/joinvaluevisitor.cpp
#include<cl/patterns/joinvaluevisitor.hpp>
#include<cl/errors.hpp>
#include<algorithm>
#include<set>

namespace ClusLib {

    void JoinValueVisitor::print(std::ostream& os) const {
        std::set<iirMapA::value_type,compare_iir>::const_iterator 
            it;
        for(it = _joinValues.begin(); it!=_joinValues.end();++it){
            os<<(it->first).first+1<<","<<(it->first).second+1
              <<","<<it->second<<'\n';
        }
    }

    std::ostream& operator<<(std::ostream& os, 
            const JoinValueVisitor& jv) {
        jv.print(os);
        return os;
    }

    void JoinValueVisitor::visit(LeafNode& node) {
    }

    void JoinValueVisitor::visit(InternalNode& node) {
        if(node.num_children() != 2){
            FAIL("JoinValueVisitor only handles " << 
                "nodes with 2 children");
        } 

        _joinValues.insert(iirMapA::value_type(
            nnPair(node[0]->get_id(), node[1]->get_id()), 
            node.get_joinValue()));

        node[0]->accept(*this);
        node[1]->accept(*this);
    }
}
