// cl/patterns/joinvaluevisitor.hpp
#ifndef CLUSLIB_JOINVALUEVISITOR_HPP
#define CLUSLIB_JOINVALUEVISITOR_HPP

#include<cl/utilities/nnmap.hpp>
#include<cl/patterns/leafnode.hpp>
#include<cl/patterns/internalnode.hpp>
#include<cl/patterns/nodevisitor.hpp>
#include<iostream>
#include<set>

namespace ClusLib {

    class JoinValueVisitor : public NodeVisitor {
    public:
        friend std::ostream& operator<<(std::ostream& os, 
                const JoinValueVisitor& jv);
        void visit(LeafNode& node);
        void visit(InternalNode& node); 
        const std::set<iirMapA::value_type, compare_iir>& 
            get_joinValues() const;

    private:
        void print(std::ostream& os) const;

        std::set<iirMapA::value_type, compare_iir> _joinValues;
    };

    inline const std::set<iirMapA::value_type, compare_iir>& 
        JoinValueVisitor::get_joinValues() const {
        return _joinValues;
    }
}

#endif
