// cl/patterns/leafnode.hpp
#ifndef CLUSLIB_LEAFNODE_HPP
#define CLUSLIB_LEAFNODE_HPP

#include<cl/patterns/node.hpp>
#include<cl/datasets/record.hpp>

namespace ClusLib {

    class LeafNode: public Node {
    public:
        LeafNode(const boost::shared_ptr<Record>& r, 
                 Size id = 0,
                 const boost::shared_ptr<Node>& p
                  = boost::shared_ptr<Node>() );

        void accept(NodeVisitor &v);
        Size num_children() const;
        Size num_records() const;
        boost::shared_ptr<Record> get_data();

    private:
        boost::shared_ptr<Record> _data;

    };

    inline Size LeafNode::num_children() const {
        return 0;
    }

    inline Size LeafNode::num_records() const {
        return 1;
    }

    inline boost::shared_ptr<Record> LeafNode::get_data() {
        return _data;
    }
}

#endif
