// cl/utilities/datasetgenerator.hpp 
#ifndef CLUSLIB_DATASETGENERATOR_HPP
#define CLUSLIB_DATASETGENERATOR_HPP

#include<cl/utilities/dataadapter.hpp>
#include<cl/utilities/matrix.hpp>
#include<vector>
#include<boost/random.hpp>

namespace ClusLib {

    class DatasetGenerator: public DataAdapter {
    public:
        DatasetGenerator(ublas::matrix<Real> mu,
                std::vector<ublas::symmetric_matrix<Real> > sigma,
                std::vector<Size> records,
                Size seed = 1);
        void fill(boost::shared_ptr<Dataset> &ds);

    protected: 
        typedef boost::variate_generator<boost::minstd_rand, 
            boost::normal_distribution<> > gen_type;

        void generate(Size ind);
        ublas::matrix<Real> _data;

        Size _seed;
        std::vector<Size> _records;
        ublas::matrix<Real> _mu;
        std::vector<ublas::symmetric_matrix<Real> > _sigma;

        gen_type _generator;
    };
}

#endif
