// cl/utilities/datasetreader.hpp
#ifndef CLUSLIB_DATASETREADER_HPP
#define CLUSLIB_DATASETREADER_HPP

#include<cl/types.hpp>
#include<cl/datasets/dataset.hpp>
#include<cl/utilities/dataadapter.hpp>
#include<vector>
#include<string>
#include<boost/shared_ptr.hpp>

namespace ClusLib {

    class DatasetReader : public DataAdapter {
    public:
        DatasetReader(const std::string& fileName);
        void fill(boost::shared_ptr<Dataset>& ds);

    private: 
        void createSchema();
        void fillData();
        boost::shared_ptr<Record> createRecord(
            const std::vector<std::string>& val); 

        std::vector<std::string> split(const std::string&);

        std::string _fileName;
        Size _labelColumn; 
        Size _idColumn; 
        Size _numColumn;

        boost::shared_ptr<Schema> _schema;
        boost::shared_ptr<Dataset> _ds;
    };

}

#endif
