// cl/utilities/null.hpp
#ifndef CLUSLIB_NULL_HPP
#define CLUSLIB_NULL_HPP

#include<cl/types.hpp>

namespace ClusLib {

    template <class Type>
    class Null;

    template <>
    class Null<Integer> {
    public:
        Null() {}
        operator Integer() const {
            return Integer(NULL_INTEGER);
        }
    };

    template <>
    class Null<Size> {
    public:
        Null() {}
        operator Size() const {
            return Size(NULL_SIZE);
        }
    };

    template<>
    class Null<Real> {
    public:
        Null() {}
        operator Real() const {
            return Real(NULL_REAL);
        }
    };
}

#endif
