// examples/nnmap/nnmap.cpp
#include<cl/utilities/nnmap.hpp>
#include<iostream>

using namespace ClusLib;
using namespace std;

typedef nnMap<Size, compare_a> MapA;
typedef nnMap<Size, compare_b> MapB;

int main() {
    MapA mA;
    mA.add_item(0, 1, 10);
    mA.add_item(0, 2, 20);
    pair<MapA::iterator, bool> reta = mA.add_item(2, 0, 40);
    cout<<"Test MapA\n    ";
    if(reta.second == false) {
        cout<<"element (2, 0) already existed with "
            <<"a value of "<<reta.first->second<<endl;
    } else {
        cout<<"value 40 is added to the map"<<endl;
    }
    MapA::iterator ita;
    cout<<"mA contains:\n";
    for(ita = mA.begin(); ita!=mA.end(); ++ita) {
        cout<<"("<<ita->first.first<<","
            <<ita->first.second<<"): "<<ita->second<<endl;
    }

    MapB mB;
    mB.add_item(0, 1, 10);
    mB.add_item(0, 2, 20);
    pair<MapB::iterator, bool> retb = mB.add_item(2, 0, 40);
    cout<<"Test MapB\n    ";
    if(retb.second == false) {
        cout<<"element (2, 0) already existed with "
            <<"a value of "<<retb.first->second<<endl;
    } else {
        cout<<"value 40 is added to the map"<<endl;
    }
    MapB::iterator itb;
    cout<<"mB contains:\n";
    for(itb = mB.begin(); itb!=mB.end(); ++itb) {
        cout<<"("<<itb->first.first<<","
            <<itb->first.second<<"): "<<itb->second<<endl;
    }

    return 0;
}
