// test-suite/cluslibtestsuite.cpp
#include<boost/test/included/unit_test_framework.hpp>

#include<iostream>
#include"attrinfo.hpp"
#include"matrix.hpp"
#include"dataset.hpp"
#include"nnmap.hpp"
#include"distance.hpp"
#include"schema.hpp"

using namespace boost::unit_test_framework;

test_suite* init_unit_test_suite(int, char* []) {
    std::string header = "Testing ClusLib";
    std::string rule = std::string(header.length(),'=');

    BOOST_MESSAGE(rule);
    BOOST_MESSAGE(header);
    BOOST_MESSAGE(rule);

    test_suite* test = BOOST_TEST_SUITE("ClusLib test suite");

    test->add(AttrInfoTest::suite()); 
    test->add(DatasetTest::suite()); 
    test->add(nnMapTest::suite()); 
    test->add(DistanceTest::suite()); 
    test->add(MatrixTest::suite()); 
    test->add(SchemaTest::suite()); 
    
    return test;
}

