// test-suite/dataset.cpp
#include"dataset.hpp" 
#include<cl/datasets/dataset.hpp> 
#include<cl/utilities/datasetreader.hpp>
#include<sstream>
#include<fstream>
#include<iostream>

using namespace ClusLib;
using namespace boost::unit_test_framework;

void DatasetTest::testDataset() {
    BOOST_MESSAGE("Testing Dataset"); 

    std::string fileName("../../Data/iris.data");
    DatasetReader reader(fileName);
    boost::shared_ptr<Dataset> ds;
    reader.fill(ds);

    std::cout<<"Num records: "<<ds->size()<<std::endl
        <<"Num attributes: "<<ds->size()<<std::endl
        <<"Num categories: "
        <<ds->schema()->labelInfo()->num_values()<<std::endl;


    Dataset ds2 = *ds; 
    std::cout<<"Num records: "<<ds2.size()<<std::endl
        <<"Num attributes: "<<ds2.size()<<std::endl
        <<"Num categories: "
        <<ds2.schema()->labelInfo()->num_values()<<std::endl;

}

test_suite* DatasetTest::suite() { 
    test_suite* suite = BOOST_TEST_SUITE("Testing Dataset");

    suite->add(BOOST_TEST_CASE(&DatasetTest::testDataset));

    return suite;
}
