// test-suite/nnmap.cpp
#include"nnmap.hpp" 
#include<cl/datasets/dataset.hpp> 
#include<cl/utilities/datasetreader.hpp>
#include<cl/utilities/nnmap.hpp>
#include<cl/distances/euclideandistance.hpp>
#include<sstream>
#include<fstream>
#include<iostream>

using namespace ClusLib;
using namespace boost::unit_test_framework;

void nnMapTest::testiirMapA() {
    BOOST_MESSAGE("Testing iirMapA"); 

    std::string fileName("../../Data/bezdekIris.data");
    DatasetReader reader(fileName);
    boost::shared_ptr<Dataset> ds; 
    reader.fill(ds);

    EuclideanDistance ed;
    iirMapA dm;
    Size n = ds->size();
    for(Size i=0;i<n;++i){
        for(Size j=i+1;j<n;++j){ 
            dm.add_item(i,j,ed((*ds)[i],(*ds)[j]));
        }
    }

    std::stringstream ss;
    for(Size i=0;i<n;++i){
        for(Size j=i+1;j<n;++j){ 
            ss<<i+1<<","<<j+1<<","<<dm(j,i)<<std::endl;
        }
    } 

    std::ofstream out("irisdm.csv");
    out<<ss.str();
    out.close();
}

void nnMapTest::testiiiMapB() {
    BOOST_MESSAGE("Testing iiiMapB"); 

    iiiMapB dm;
    Size n = 10;
    for(Size i=0;i<n;++i){
        for(Size j=0;j<n;++j){ 
            dm.add_item(i,j,i+j);
        }
    }

    std::stringstream ss;
    for(Size i=0;i<n;++i){
        for(Size j=0;j<n;++j){ 
            ss<<i+1<<","<<j+1<<","<<dm(j,i)<<std::endl;
        }
    } 

    std::ofstream out("iirmapb.csv");
    out<<ss.str();
    out.close();
}

test_suite* nnMapTest::suite() { 
    test_suite* suite = BOOST_TEST_SUITE("Testing nnMap");

    suite->add(BOOST_TEST_CASE(&nnMapTest::testiirMapA));
    suite->add(BOOST_TEST_CASE(&nnMapTest::testiiiMapB));

    return suite;
} 
